/**
 * Copyright (c) 2011, Regents of the University of California
 * All rights reserved.
 * <p/>
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * <p/>
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * <p/>
 * 2. Redistributions in binary form must reproduce the above
 * copyright notice, this list of conditions and the following
 * disclaimer in the documentation and/or other materials provided
 * with the distribution.
 * <p/>
 * 3. Neither the name of the University of California, Berkeley nor
 * the names of its contributors may be used to endorse or promote
 * products derived from this software without specific prior written
 * permission.
 * <p/>
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package edu.berkeley.cs.wise.concolic;

/**
 * @author Koushik Sen <ksen@cs.berkeley.edu>
 * @author Jacob Burnim <jburnim@cs.berkeley.edu>
 */
public class InputImpl implements Input {

    public long Long() {
        return Long(Long.MIN_VALUE, Long.MAX_VALUE);
    }

    public long Long(long defaultVal) {
        return ObserverForConcolic.Long(Long.MIN_VALUE, Long.MAX_VALUE, defaultVal);
    }

    public long Long(long MIN, long MAX) {
        return ObserverForConcolic.Long(MIN, MAX, 0);
    }

    public int Integer() {
        return Integer(Integer.MIN_VALUE, Integer.MAX_VALUE);
    }

    public int Integer(int defaultVal) {
        return ObserverForConcolic.Integer(Integer.MIN_VALUE, Integer.MAX_VALUE, defaultVal);
    }

    public int Integer(int MIN, int MAX) {
        return ObserverForConcolic.Integer(MIN, MAX, 0);
    }

    public char Character() {
        return Character(Character.MIN_VALUE, Character.MAX_VALUE);
    }

    public char Character(char defaultVal) {
        return ObserverForConcolic.Character(Character.MIN_VALUE, Character.MAX_VALUE, defaultVal);
    }

    public char Character(char MIN, char MAX) {
        return ObserverForConcolic.Character(MIN, MAX, 0);
    }

    public short Short() {
        return Short(Short.MIN_VALUE, Short.MAX_VALUE);
    }

    public short Short(short defaultVal) {
        return ObserverForConcolic.Short(Short.MIN_VALUE, Short.MAX_VALUE, defaultVal);
    }

    public short Short(short MIN, short MAX) {
        return ObserverForConcolic.Short(MIN, MAX, 0);
    }

    public byte Byte() {
        return Byte(Byte.MIN_VALUE, Byte.MAX_VALUE);
    }

    public byte Byte(byte defaultVal) {
        return ObserverForConcolic.Byte(Byte.MIN_VALUE, Byte.MAX_VALUE, defaultVal);
    }

    public byte Byte(byte MIN, byte MAX) {
        return ObserverForConcolic.Byte(MIN, MAX, 0);
    }

    public boolean Boolean() {
        return ObserverForConcolic.Boolean(0);
    }

    public boolean Boolean(boolean defaultVal) {
        return ObserverForConcolic.Boolean(defaultVal ? 1 : 0);
    }
}
